<?php
class installerDpr {
	static public $update_to_version_method = '';
	static private $_firstTimeActivated = false;
	static public function init() {
		global $wpdb;
		$wpPrefix = $wpdb->prefix; /* add to 0.0.3 Versiom */
		//$start = microtime(true);					// Speed debug info
		//$queriesCountStart = $wpdb->num_queries;	// Speed debug info
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		$current_version = get_option($wpPrefix. DPR_DB_PREF. 'db_version', 0);
		if(!$current_version)
			self::$_firstTimeActivated = true;
		/**
		 * htmltype 
		 */
		if (!dbDpr::exist("@__htmltype")) {
			dbDelta(dbDpr::prepareQuery("CREATE TABLE IF NOT EXISTS `@__htmltype` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `label` varchar(32) NOT NULL,
			  `description` varchar(255) NOT NULL,
			  PRIMARY KEY (`id`),
			  UNIQUE INDEX `label` (`label`)
			) DEFAULT CHARSET=utf8"));
			dbDpr::query("INSERT INTO `@__htmltype` VALUES
				(1, 'text', 'Text'),
				(2, 'password', 'Password'),
				(3, 'hidden', 'Hidden'),
				(4, 'checkbox', 'Checkbox'),
				(5, 'checkboxlist', 'Checkboxes'),
				(6, 'datepicker', 'Date Picker'),
				(7, 'submit', 'Button'),
				(8, 'img', 'Image'),
				(9, 'selectbox', 'Drop Down'),
				(10, 'radiobuttons', 'Radio Buttons'),
				(11, 'countryList', 'Countries List'),
				(12, 'selectlist', 'List'),
				(13, 'countryListMultiple', 'Country List with posibility to select multiple countries'),
				(14, 'block', 'Will show only value as text'),
				(15, 'statesList', 'States List'),
				(16, 'textFieldsDynamicTable', 'Dynamic table - multiple text options set'),
				(17, 'textarea', 'Textarea'),
				(18, 'checkboxHiddenVal', 'Checkbox with Hidden field')");
		}
		/**
		 * modules 
		 */
		if (!dbDpr::exist("@__modules")) {
			dbDelta(dbDpr::prepareQuery("CREATE TABLE IF NOT EXISTS `@__modules` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `code` varchar(64) NOT NULL,
			  `active` tinyint(1) NOT NULL DEFAULT '0',
			  `type_id` smallint(3) NOT NULL DEFAULT '0',
			  `params` text,
			  `label` varchar(128) DEFAULT NULL,
			  `ex_plug_dir` varchar(255) DEFAULT NULL,
			  PRIMARY KEY (`id`),
			  UNIQUE INDEX `code` (`code`)
			) DEFAULT CHARSET=utf8;"));
			dbDpr::query("INSERT INTO `@__modules` (id, code, active, type_id, params, label) VALUES
				(NULL, 'adminmenu',1,1,'','Admin Menu'),
				(NULL, 'book',1,1,'','book'),
				(NULL, 'options',1,1,'','Options'),
				(NULL, 'user',1,1,'','Users'),
				(NULL, 'page',1,1,'','Pages'),
				(NULL, 'pages',1,1,'". json_encode(array()). "','Pages'),
				(NULL, 'templates',1,1,'','Templates for Plugin'),
				(NULL, 'dpr',1,1,'','Digital Publications Ready'),
				(NULL, 'promo_ready',1,1,'','promo_ready');");
		}
		/*THIS IS TEMP!!! REMOVE THIS!!!!!*/
		dbDpr::query("INSERT INTO `@__modules` (id, code, active, type_id, params, label) VALUES
				(NULL, 'promo_ready',1,1,'','promo_ready');");
		/**
		 *  modules_type 
		 */
		if(!dbDpr::exist("@__modules_type")) {
			dbDelta(dbDpr::prepareQuery("CREATE TABLE IF NOT EXISTS `@__modules_type` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `label` varchar(64) NOT NULL,
			  PRIMARY KEY (`id`)
			) AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;"));
			dbDpr::query("INSERT INTO `@__modules_type` VALUES
				(1,'system'),
				(6,'addons');");
		}
		/**
		 *  pages sort order 
		 */
		if(!dbDpr::exist("@__page_sort_order")) {
			dbDelta(dbDpr::prepareQuery("CREATE TABLE IF NOT EXISTS `@__page_sort_order` (
			  `book_id` int(11) NOT NULL,
			  `page_id` int(11) NOT NULL,
			  `sort_order` int(7) NOT NULL,
			  INDEX `page_id_F1_1` (`page_id`)
			)DEFAULT CHARSET=utf8;"));
		}
		/**
		 *  pages that is images
		 */
		if(!dbDpr::exist("@__page_as_img")) {
			dbDelta(dbDpr::prepareQuery("CREATE TABLE IF NOT EXISTS `@__page_as_img` (
			  `page_id` int(11) NOT NULL,
			  `attach_id` int(11) NOT NULL,
			  `img_url` VARCHAR(255) NOT NULL,
			  INDEX `page_id_F1_1` (`page_id`)
			)DEFAULT CHARSET=utf8;"));
		}
		/**
		* Plugin usage statistics
		*/
		if(!dbDpr::exist("@__usage_stat")) {
			dbDelta(dbDpr::prepareQuery("CREATE TABLE `@__usage_stat` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `code` varchar(64) NOT NULL,
			  `visits` int(11) NOT NULL DEFAULT '0',
			  `spent_time` int(11) NOT NULL DEFAULT '0',
			  `modify_timestamp` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
			  UNIQUE INDEX `code` (`code`),
			  PRIMARY KEY (`id`)
			) DEFAULT CHARSET=utf8"));
			dbDpr::query("INSERT INTO `@__usage_stat` (code, visits) VALUES ('installed', 1)");
		}
		installerDbUpdaterDpr::runUpdate();
		if($current_version && !self::$_firstTimeActivated) {
			self::setUsed();
		}
		update_option($wpPrefix. DPR_DB_PREF. 'db_version', DPR_VERSION);
		add_option($wpPrefix. DPR_DB_PREF. 'db_installed', 1);
		//$time = microtime(true) - $start;	// Speed debug info
	}
	static public function setUsed() {
		update_option(DPR_DB_PREF. 'plug_was_used', 1);
	}
	static public function isUsed() {
		return (int) get_option(DPR_DB_PREF. 'plug_was_used');
	}
	static public function delete() {
		global $wpdb;
		$wpPrefix = $wpdb->prefix;
		$wpdb->query("DROP TABLE IF EXISTS `".$wpPrefix.DPR_DB_PREF."modules`");
		$wpdb->query("DROP TABLE IF EXISTS `".$wpPrefix.DPR_DB_PREF."modules_type`");
		$wpdb->query("DROP TABLE IF EXISTS `".$wpPrefix.DPR_DB_PREF."htmltype`");
		$wpdb->query("DROP TABLE IF EXISTS `".$wpPrefix.DPR_DB_PREF."page_sort_order`");
		$wpdb->query("DROP TABLE IF EXISTS `".$wpPrefix.DPR_DB_PREF."usage_stat`");
		delete_option($wpPrefix. 'db_version');
		delete_option($wpPrefix. 'db_installed');
	}
	static public function update() {
		global $wpdb;
		$wpPrefix = $wpdb->prefix; /* add to 0.0.3 Versiom */
		$currentVersion = get_option($wpPrefix. 'db_version', 0);
		if(!$currentVersion || version_compare(DPR_VERSION, $currentVersion, '>')) {
			self::init();
			update_option($wpPrefix. 'db_version', DPR_VERSION);
		}
	}
}
