<?php
class adminmenuDpr extends moduleDpr {
	protected $_mainSlug = 'digital-publication-ready';
    public function init() {
        parent::init();
		add_action('admin_menu', array($this, 'initMenu'), 9);
		$plugName = plugin_basename(DPR_DIR. DPR_MAIN_FILE);
		add_filter('plugin_action_links_'. $plugName, array($this, 'addSettingsLinkForPlug') );
    }
	public function addSettingsLinkForPlug($links) {
		array_unshift($links, '<a href="'. uriDpr::_(array('baseUrl' => admin_url('admin.php'), 'page' => $this->getMainSlug())). '">'. __('Settings', DPR_LANG_CODE). '</a>');
		return $links;
	}
	public function initMenu() {
		$mainSlug = dispatcherDpr::applyFilters('adminMenuMainSlug', $this->_mainSlug);
		$mainMenuPageOptions = array(
			'page_title' => DPR_WP_PLUGIN_NAME, 
			'menu_title' => DPR_WP_PLUGIN_NAME, 
			'capability' => 'manage_options',
			'menu_slug' => $mainSlug,
			'function' => array(frameDpr::_()->getModule('options')->getView(), 'getAdminPage'));
		$mainMenuPageOptions = dispatcherDpr::applyFilters('adminMenuMainOption', $mainMenuPageOptions);
        add_menu_page($mainMenuPageOptions['page_title'], $mainMenuPageOptions['menu_title'], $mainMenuPageOptions['capability'], $mainMenuPageOptions['menu_slug'], $mainMenuPageOptions['function'], 'dashicons-book');
		 
		$subMenus = array(
			array('title' => __('Publications', DPR_LANG_CODE), 'capability' => 'manage_options', 'menu_slug' => 'edit-tags.php?taxonomy='. DPR_BOOK, 'function' => ''),
			array('title' => __('Pages', DPR_LANG_CODE),	'capability' => 'manage_options', 'menu_slug' => 'edit.php?post_type='. DPR_PAGE,	'function' => ''),
		);
		$subMenus = dispatcherDpr::applyFilters('adminMenuOptions', $subMenus);
		foreach($subMenus as $opt) {
			add_submenu_page($mainSlug, $opt['title'], $opt['title'], $opt['capability'], $opt['menu_slug'], $opt['function']);
		}
	}
	public function getMainSlug() {
		return $this->_mainSlug;
	}
}

