<?php
class bookControllerDpr extends controllerDpr { 
	private $_displayHtml = '';
	private $_displayId = 0;
	public function preview() {
		add_action('init', array($this, 'doPreview'), 99);
	}
	public function doPreview() {
		$paramsDesc = $this->getModule()->getBookParamsDesc();
		$get = reqDpr::get('get');
		$this->_displayId = (int) reqDpr::getVar('id');
		$getBookParams = array('id' => $this->_displayId);
		foreach($paramsDesc as $k => $v) {
			if(isset($get[ $k ]))
				$getBookParams[ $k ] = $get[ $k ];
		}
		$this->_displayHtml = $this->getModule()->displayBook($getBookParams);
		$this->getView()->displayBookPreview( array('bookHtml' => $this->_displayHtml, 'id' => $this->_displayId) );
		exit();
	}
	public function addPagesFromImages() {
		$res = new responseDpr();
		$post = reqDpr::get('post');
		if($this->getModel()->addPagesFromImages($post)) {
			$batchRes = $this->getModel()->getBatchResults();
			$res->addMessage(sprintf(__('Added %d from %d pages', DPR_LANG_CODE), $batchRes['success'], $batchRes['total']));
			// Update book params after import pages - as we will reload page, and some settings can be lost
			if(isset($post['bookParams']) 
				&& !empty($post['bookParams']) 
				&& isset($post['bookParams']['dpr']) 
				&& !empty($post['bookParams']['dpr'])
			) {
				$updateTaxData = $post['bookParams'];
				$tag_ID = (int) $updateTaxData['tag_ID'];
				$taxonomy = $updateTaxData['taxonomy'];
				if($tag_ID && $taxonomy == DPR_BOOK) {
					wp_update_term( $tag_ID, $taxonomy, $updateTaxData );
				}
			}
		} else
			$res->pushError ($this->getModel()->getErrors());
		
		$addFrom = '';
		if(isset($post['batch_pages']['attach_id'])) {
			$addFrom = 'wpimages';
		} elseif(isset($post['batch_pages']['img_url'])) {
			$addFrom = 'ftp';
		}
		frameDpr::_()->getModule('promo_ready')->getModel()->saveUsageStat('page.batch.add.from.'. $addFrom);
		$res->ajaxExec();
	}
	public function parseFolderForImages() {
		$res = new responseDpr();
		if(($filesList = $this->getModel()->parseFolderForImages(reqDpr::get('post')))) {
			$res->addMessage(__('Done', DPR_LANG_CODE));
			$res->addData('filesList', $filesList);
		} else
			$res->pushError ($this->getModel()->getErrors());
		$res->ajaxExec();
	}
	public function exportToHtml() {
		add_action('init', array($this, 'doExportHtml'), 99);
	}
	public function doExportHtml() {
		$id = (int) reqDpr::getVar('id');
		if($id) {
			echo $this->getView()->getExportHtml($id);
		}
		exit();
	}
	public function exportToPdf() {
		add_action('init', array($this, 'doExportPdf'), 99);
	}
	public function doExportPdf() {
		$id = (int) reqDpr::getVar('id');
		if($id) {
			if (!$this->getModule()->canUsePdfExport()) {
				echo 'You need to have at least php 5.3 version to use this feature';
				exit();
			}
			require_once($this->getModule()->getModDir(). 'classes'. DS. 'dom2pdf'. DS. 'dompdf_config.inc.php');
			$content = $this->getView()->getExportHtml($id, array('simple' => true));
			if(function_exists('base64_encode')) {
				preg_match_all('/src="([^"]*)"/i', $content, $imgSrcRes);
				if($imgSrcRes && !empty($imgSrcRes[0]) && !empty($imgSrcRes[1])) {
					foreach($imgSrcRes[1] as $i => $url) {
						$url = trim($url);
						if(empty($url)) continue;
						$content = str_replace($imgSrcRes[0][ $i ], 'src="'. str_replace(DPR_SITE_URL, '', $url). '"', $content);
						// Other way - is to include img as content, but it didn't worked for us
						/*$imgFullPath = str_replace(DPR_SITE_URL, ABSPATH, $url);
						if(file_exists($imgFullPath)) {
							$mime = wp_check_filetype($imgFullPath);
							if(!empty($mime['type'])) {
								$content = str_replace($imgSrcRes[0][ $i ], 'src="data:'. $mime['type']. ';base64,'. base64_encode(file_get_contents($imgFullPath)). '"', $content);
							}
						}*/
					}
				}
			}
			$book = $this->getModel()->getById($id, false, true);
			$dompdf = new DOMPDF();
			$dompdf->load_html($content);
			$dompdf->render();
			$dompdf->stream($book->name. '.pdf');
		}
		exit();
	}
	/**
	 * @see controller::getPermissions();
	 */
	public function getPermissions() {
		return array(
			DPR_USERLEVELS => array(
				DPR_ADMIN => array('preview', 'doPreview', 'addPagesFromImages', 'parseFolderForImages')
			),
		);
	}
}
