var dprTimeoutForBatchGallerySet = false;
jQuery(document).ready(function(){
	// Move all book properties - to tabs
	var formTableData = jQuery('#edittag').find('.form-table:first');
	if(formTableData && formTableData.size()) {
		jQuery('#dprAdminBookProperties').append( formTableData );
	}
	jQuery('#edittag').find('[data-original-name]').change(function(){
		var changedPrams = {}
		,	name = jQuery(this).attr('data-original-name')
		,	value = '';
		if(jQuery(this).attr('type') == 'checkbox') {
			value = jQuery(this).attr('checked') ? 1 : 0;
		} else {
			value = jQuery(this).val();
		}
		changedPrams[ name ] = value;
		dprLivePreviewParams.update( changedPrams );
	});
	jQuery('.dprTabsShell').wpTabs({
		change: function(selector) {
			// Show update and preview buttons - only for those tabs
			if(toeInArray(selector, ['#dprAdminBookProperties', '#dprAdminBookPages', '#dprAdminBookTableOfContents']) !== -1) {
				jQuery('#edittag').find('p.submit').show();
			} else {
				jQuery('#edittag').find('p.submit').hide();
			}
		}
	});
	jQuery('#dprAdminBookAddBatchFromImagesTbl').sortable({
		update: function(event, ui) {
			dprSetPagesSortOrderVal({
				htmlShell: '#dprAdminBookAddBatchFromImagesTbl'
			});
		}
	});
	jQuery('#dprAdminBookAddBatchFromImagesTbl').disableSelection();
	jQuery('#dprAdminBookAddBatchFromServerDirTbl').sortable({
		update: function(event, ui) {
			dprSetPagesSortOrderVal({
				htmlShell: '#dprAdminBookAddBatchFromServerDirTbl'
			});
		}
	});
	jQuery('#dprAdminBookAddBatchFromServerDirTbl').disableSelection();
	jQuery('#dprAdminBookPagesShell').sortable({
		update: function(event, ui) {
			dprSetPagesSortOrderVal({
				htmlShell: '#dprAdminBookPagesShell'
			,	addSortOrder: true
			});
		}
	});
	jQuery('#dprAdminBookPagesShell').disableSelection();
	jQuery('.dprAdminCreateBatchPagesFromImagesBtn').click(function(){
		dprSaveBatchData({
			inputShell: jQuery('#dprAdminBookAddBatchFromImagesTbl').find('li:not(.dprRowExample)')
		,	msgElID: jQuery('.dprAdminCreateBatchPagesFromImagesMsg')
		,	bookId: jQuery(this).data('bookid')
		});
		return false;
	});
	jQuery('#dprAdminAddPagesParseFolderBtn').click(function(){
		var folder = jQuery('[name="add_batch_serv_path"]').val();
		jQuery.sendFormDpr({
			msgElID: 'dprAdminAddPagesParseFolderMsg'
		,	data: {mod: 'book', action: 'parseFolderForImages', folder: folder, reqType: 'ajax'}
		,	onSuccess: function(res) {
				if(!res.error) {
					for(var i in res.data.filesList) {
						dprBookParsedBatchImgToList({
							addToHtml: '#dprAdminBookAddBatchFromServerDirTbl'
						,	imgUrl: res.data.filesList[i].path
						,	title: res.data.filesList[i].title
						});
					}
					jQuery('.dprBookAddPagesSubmitShell').show();
					drpSortBatch('#dprAdminBookAddBatchFromServerDirTbl', 'title', 'DESC');
				}
			}
		});
		return false;
	});
	jQuery('.dprAdminCreateBatchPagesFromServerDirBtn').click(function(){
		dprSaveBatchData({
			inputShell: jQuery('#dprAdminBookAddBatchFromServerDirTbl').find('li:not(.dprRowExample)')
		,	msgElID: jQuery('.dprAdminCreateBatchPagesFromServerDirMsg')
		,	bookId: jQuery(this).data('bookid')
		});
		return false;
	});
	jQuery('.dprRemovePageCheck').change(function(){
		var totalChecked = jQuery('.dprRemovePageCheck:checked').size()
		if(totalChecked) {
			jQuery('.dprRemovePagesBtn').show();
			if(totalChecked == jQuery('.dprRemovePageCheck').size()) {
				jQuery('#dprSelectAllPagesCheck').prop('indeterminate', false);
				jQuery('#dprSelectAllPagesCheck').attr('checked', 'checked');
			} else {
				jQuery('#dprSelectAllPagesCheck').prop('indeterminate', true);
			}
		} else {
			jQuery('.dprRemovePagesBtn').hide();
			jQuery('#dprSelectAllPagesCheck').prop('indeterminate', false);
			jQuery('#dprSelectAllPagesCheck').removeAttr('checked');
		}
		return false;
	});
	jQuery('.dprRemovePagesBtn').click(function(){
		var removeIds = [];
		jQuery('.dprRemovePageCheck:checked').each(function(){
			removeIds.push( jQuery(this).parents('.dprTemplatePrevShell').data('id') );
		});
		dprRemovePage( removeIds );
		return false;
	});
	jQuery('#dprAdminBookPages').on('click', '.dprAdminBookRemovePageBtn', function(){
		dprRemovePage(jQuery(this).parents('.dprTemplatePrevShell').data('id'));
		return false;
	});
	jQuery('#edittag').find('[name=_wp_original_http_referer]').val(dprGetBookEditLink(jQuery('#edittag').find('[name=tag_ID]').val()));
	jQuery('#dprSelectAllPagesCheck').change(function(){
		dprSelectAllCheck( jQuery(this).attr('checked') );
	});
	jQuery('#dprSelectAllPagesCheck').removeAttr('checked');
	
	jQuery('.swrAdminBookToolbarSelectItem').click(function(){
		dprSelectAdminToolbar(jQuery(this).data('code'));
		return false;
	});
	if(dprBook && dprBook.params && dprBook.params.toolbar_code) {
		dprSelectAdminToolbar( dprBook.params.toolbar_code );
	}
});
function dprSelectAdminToolbar(code) {
	jQuery('.swrAdminBookToolbarSelectItem').removeClass('dprActive');
	var inputField = jQuery('#edittag input[name="dpr[toolbar_code]"]');
	inputField.val('');
	if(code && code != '') {
		jQuery('.swrAdminBookToolbarSelectItem[data-code="'+ code+ '"]').addClass('dprActive');
		inputField.val( code ).trigger('change');
	}
}
function wpColorPicker_dprbg_color_change(event, ui) {
	dprLivePreviewParams.update({
		bg_color: encodeURI(ui.color.toString())
	});
}
function drpClearBatch(shellSelector) {
	jQuery(shellSelector).find('li:not(.dprRowExample)').each(function(){
		jQuery(this).find('.dprTemplatePrevActionShell .dashicons-trash').click();
	});
}
/**
 * Sort batch results
 * @param {string|object} shellSelector List shell selector or html element
 * @param {string} sortBy Sort by argument, currently supported - "title"
 * @param {string} forceDir If is set - we will take sort direction from it
 */
function drpSortBatch(shellSelector, sortBy, forceDir) {
	var shell = jQuery(shellSelector)
	,	cells = shell.find('li:not(.dprRowExample)');
	if(cells.size()) {
		var btn = shell.parents('.dprTabContent').find('.dprSortBatchBtn')
		,	dirElement = jQuery(btn).find('.dprBatchSortDirIcon')
		,	sortDir = jQuery(dirElement).hasClass('dashicons-arrow-down') ? 'ASC' : 'DESC';
		if(forceDir)
			sortDir = forceDir;
		cells.sort(function (a, b) {
			switch(sortBy) {
				case 'title':
					var valA = jQuery(a).find('[name="batch_pages[titles][]"]').val().toUpperCase()
					,	valB = jQuery(b).find('[name="batch_pages[titles][]"]').val().toUpperCase();
					if(!isNaN(parseInt(valA)) && !isNaN(parseInt(valB))) {
						valA = parseInt(valA);
						valB = parseInt(valB);
					}
					if(sortDir == 'DESC')
						return valA > valB;
					else
						return valA < valB;
					break;
			}
		});
		sortDir == 'DESC' 
			? jQuery(dirElement).removeClass('dashicons-arrow-up').addClass('dashicons-arrow-down') 
			: jQuery(dirElement).removeClass('dashicons-arrow-down').addClass('dashicons-arrow-up');
		shell.append(cells);
		dprSetPagesSortOrderVal({
			htmlShell: shellSelector
		});
	}
}
// Rebuild and re-positionate page elements after page load and 2seconds
// as it just didn't work in other way
jQuery(window).bind('load', function(){
	dprSetPagesSortOrderVal({
		htmlShell: '#dprAdminBookPagesShell'
	,	addSortOrder: true
	});
	setTimeout(function(){
		// Disable zooming for now
		/*jQuery('.dprTemplatePrevContent').each(function(){
			//jQuery(this).zoom(0.5);
		});*/
		
	}, 3000);
});
function dprSetPagesSortOrderVal(params) {
	params = params || {};
	var sortOrderArr = []
	,	i = 1
	,	htmlShell = params.htmlShell 
		? typeof(params.htmlShell) === 'string' 
			? jQuery(params.htmlShell) 
			: params.htmlShell
		: jQuery('#dprAdminBookPagesShell')
	,	pagesHtml = htmlShell.find('li.dprTemplatePrevShell:not(.dprRowExample)')
	,	pagesNum = pagesHtml.size();
	pagesHtml.each(function(){
		jQuery(this).removeClass('even').removeClass('odd').removeClass('first').removeClass('last').removeClass('dprClearLeft');
		if(i === 1)
			jQuery(this).addClass('first');
		if(i === pagesNum)
			jQuery(this).addClass('last');
		var pos = i % 2 === 0
			? 'even'
			: 'odd';
		jQuery(this).addClass( pos );
		jQuery(this).find('.dprTemplatePrevPageNum').html( i );
		if(params.addSortOrder)
			sortOrderArr.push(jQuery(this).data('id')+ ':'+ i);
		i++;
	});
	pagesHtml.each(function(){
		// If this element - is first of 2 in set, and next element - is already in net row - move this element to next row too
		if(jQuery(this).hasClass('even')) {
			var pos = jQuery(this).position()
			,	nextPos = jQuery(this).next().position();
			if(nextPos && nextPos.top != pos.top) {
				jQuery(this).addClass('dprClearLeft');
			}
		}
	});
	if(params.addSortOrder)
		jQuery('input[name="dpr[pages_sort_order]"]').val(sortOrderArr.join(','));
}
function dprAddImgForBatchPage(url, attach) {
	if(url && attach) {
		dprBookParsedBatchImgToList({
			addToHtml: '#dprAdminBookAddBatchFromImagesTbl'
		,	imgUrl: url
		,	title: attach.title
		,	attachId: attach.id
		});
		if(!dprTimeoutForBatchGallerySet) {
			setTimeout(function(){
				dprTimeoutForBatchGallerySet = false;
				drpSortBatch('#dprAdminBookAddBatchFromImagesTbl', 'title', 'DESC');
			}, 300);
			dprTimeoutForBatchGallerySet = true;
			jQuery('#dprAdminBookAddBatchFromImagesTbl').parents('.dprTabContent').find('.dprBookAddPagesSubmitShell').show();
		}
	}
}
function dprAdminRemoveAddRow(link) {
	if(jQuery(link).parents('ul:first').find('li:not(.dprRowExample)').size() == 1) {	// Current row - is last one
		jQuery(link).parents('.dprTabContent').find('.dprBookAddPagesSubmitShell').hide();
	}
	// We should set this here, as we can't get parent ul after cell will be removed
	var shellContent = jQuery(link).parents('ul:first');
	jQuery(link).parents('li:first').animateRemoveDpr(300, function(){
		dprSetPagesSortOrderVal({
			htmlShell: shellContent
		});
	});
}
function dprSaveBatchData(params) {
	var saveDataShell = typeof(params.inputShell) == 'string' ? jQuery('#'+ params.inputShell) : params.inputShell
	,	saveData = saveDataShell.serializeAnythingDpr({
			mod: 'book'
		,	action: 'addPagesFromImages'
		,	reqType: 'ajax'
		,	id: params.bookId
		,	bookParams: jQuery('#edittag').serializeAssoc()
	});
	jQuery.sendFormDpr({
		msgElID: params.msgElID
	,	data: saveData
	,	onSuccess: function(res) {
			if(!res.error) {
				if(!params.ignoreReload) {
					adminFormSavedDpr('edittag');
					// Reload page on pages list tab
					dprReloadToBookTab('dprAdminBookPages');
				}
			}
			if(params.onSuccess && typeof(params.onSuccess) == 'function') {
				params.onSuccess(res);
			}
		}
	});
}
function dprReloadToBookTab(tab) {
	var url = document.location.origin+ document.location.pathname+ document.location.search;
	if(tab)
		url += '#'+ tab;
	toeReload( url );
}
function dprRemovePage(ids) {
	var manyPagesRemove = ((typeof(ids) == 'array' || typeof(ids) == 'object') && ids.length > 1)
	,	confirmMsg =  manyPagesRemove 
		? str_replace(toeLangDpr('Are you sure want to remove %d pages?'), '%d', ids.length)
		: toeLangDpr('Are you sure want to remove this page?')
	,	firstId = manyPagesRemove 
		? 0 
		: (typeof(ids) == 'array' || typeof(ids) == 'object')
			? ids[0]
			: ids;
	if(confirm(confirmMsg)) {
		var msg = '';
		if(firstId) {
			msg = jQuery('.dprTemplatePrevShell[data-id="'+ firstId+ '"]').find('.dprPagePrevMsg');
		} else
			msg = 'dprRemovePagesMsg';
		jQuery.sendFormDpr({
			msgElID: msg
		,	data: {mod: 'page', action: 'remove', id: ids, reqType: 'ajax'}
		,	onSuccess: function(res) {
				if(!res.error) {
					if(firstId) {
						jQuery('.dprTemplatePrevShell[data-id="'+ firstId+ '"]').animateRemoveDpr(300);
					} else {
						for(var i in ids) {
							jQuery('.dprTemplatePrevShell[data-id="'+ ids[i]+ '"]').animateRemoveDpr(300);
						}
					}
					setTimeout(function(){
						dprSetPagesSortOrderVal();
					}, 300);
				}
			}
		});
	}
}
function dprBookParsedBatchImgToList(params) {
	params = params || {};
	var addToHtml = typeof(params.addToHtml) === 'string' ? jQuery(params.addToHtml) : params.addToHtml
	,	newCell = addToHtml.find('.dprRowExample:first').clone().removeClass('dprRowExample');
	if(params.imgUrl) {
		newCell.find('.dprTemplateImg').attr('src', params.imgUrl);
	}
	if(params.title) {
		newCell.find('[name="batch_pages[titles][]"]').val(params.title);
	}
	if(params.attachId) {
		newCell.find('[name="batch_pages[attach_id][]"]').val(params.attachId);
	} else if(params.imgUrl) {
		newCell.find('[name="batch_pages[img_url][]"]').val(params.imgUrl);
	}
	addToHtml.append(newCell);
}
function dprSplitBtn(link) {
	dprSplitPage({
		pageId: jQuery(link).parents('.dprTemplatePrevShell').data('id')
	,	msgEl: jQuery(link).parents('.dprTemplatePrevShell').find('.dprPagePrevMsg')
	,	sortOrder: jQuery('input[name="dpr[pages_sort_order]"]').val()
	});
}
function dprMergeBtn(link) {
	var cell = jQuery(link).parents('.dprTemplatePrevShell')
	,	mergeWithCell = null
	,	mergeWithNext = false;
	if(cell.hasClass('first')) {	// For first cell - just try take next one
		mergeWithCell = cell.next();
		mergeWithNext = true;
	} else if(cell.hasClass('last')) {	// For last - try take prev cell
		mergeWithCell = cell.prev();
	} else if(cell.hasClass('even')) {	// For even cell - take next
		mergeWithCell = cell.next();
		mergeWithNext = true;
	} else if(cell.hasClass('odd')) {	// For odd - take odd
		mergeWithCell = cell.prev();
	}
	if(mergeWithCell && mergeWithCell.size()) {
		if(mergeWithCell.hasClass('dprPageImg')) {
			var mergeId = mergeWithCell.data('id')
			,	pageId = cell.data('id')
			,	pageIds = [];
			pageIds = mergeWithNext ? [pageId, mergeId] : [mergeId, pageId];
			dprMergePages({
				pageIds: pageIds
			,	msgEl: cell.find('.dprPagePrevMsg')
			,	sortOrder: jQuery('input[name="dpr[pages_sort_order]"]').val()
			});
		} else
			alert(toeLangDpr('You can merge only pages, that was created from images. Try to place page, created from image, near desireded page.'));
	} else
		alert('Can not find page for merging!');
}
function dprSplitPage(params) {
	params = params || {};
	jQuery.sendFormDpr({
		msgElID: params.msgEl
	,	data: {mod: 'page', action: 'split', id: params.pageId, sort_order: params.sortOrder, reqType: 'ajax'}
	,	onSuccess: function(res) {
			if(!res.error) {
				var cellHtml = jQuery('.dprTemplatePrevShell-'+ params.pageId)
				,	anim = 300;
				for(var i in res.data.addedPages) {
					var newCell = dprClonePageCell(cellHtml, params.pageId, res.data.addedPages[i], {hide: true});
					newCell.insertBefore( cellHtml );
					newCell.show(anim);
				}
				cellHtml.animateRemoveDpr(anim);
				setTimeout(function(){
					dprSetPagesSortOrderVal({
						htmlShell: '#dprAdminBookPagesShell'
					,	addSortOrder: true
					});
				}, anim);
			}
		}
	});
}
function dprMergePages(params) {
	params = params || {};
	jQuery.sendFormDpr({
		msgElID: params.msgEl
	,	data: {mod: 'page', action: 'merge', ids: params.pageIds, sort_order: params.sortOrder, reqType: 'ajax'}
	,	onSuccess: function(res) {
			if(!res.error) {
				var firstPageId = params.pageIds[0]
				,	firstCellHtml = jQuery('.dprTemplatePrevShell-'+ firstPageId)
				,	newCell = dprClonePageCell(firstCellHtml, firstPageId, res.data.addedPage, {hide: true})
				,	anim = 300;
				newCell.insertBefore( firstCellHtml );
				// Remove old cells
				for(var i in params.pageIds) {
					jQuery('.dprTemplatePrevShell-'+ params.pageIds[i]).animateRemoveDpr(anim);
				}
				newCell.show(anim);
				setTimeout(function(){
					dprSetPagesSortOrderVal({
						htmlShell: '#dprAdminBookPagesShell'
					,	addSortOrder: true
					});
				}, anim);
			}
		}
	});
}
function dprClonePageCell(original, originalId, newPage, params) {
	params = params || {};
	var newCell = original.clone();
	newCell
		.removeClass('dprTemplatePrevShell-'+ originalId)
		.addClass('dprTemplatePrevShell-'+ newPage.ID)
		.attr('data-id', newPage.ID);
	newCell.find('.dprTemplatePageTitle').html(newPage.post_title);
	newCell.find('.dprTemplatePrevContent').html(newPage.post_content);
	newCell.find('.dashicons-edit').attr('href', newPage.edit_link);
	newCell.find('.dprPagePrevMsg').html('');
	if(params.hide)
		newCell.hide;
	return newCell;
}
function dprSelectAllCheck(value) {
	var cells = jQuery('#dprAdminBookPagesShell').find('li:not(.dprRowExample)');
	if(cells.size()) {
		cells.each(function(){
			var checkbox = jQuery(this).find('.dprRemovePageCheck');
			value ? checkbox.attr('checked', 'checked') : checkbox.removeAttr('checked');
		});
		value ? jQuery('.dprRemovePagesBtn').show() : jQuery('.dprRemovePagesBtn').hide();
	}
}
