function dprOnAdminBgImgChange(imgUrl) {
	if(imgUrl && imgUrl != '') {
		jQuery('#dprAdminBookBgImgPrev').show().attr('src', imgUrl);
	} else {
		jQuery('#dprAdminBookBgImgPrev').hide();
	}
}
function dprOnAdminPageBgImgChange(imgUrl) {
	if(imgUrl && imgUrl != '') {
		jQuery('#dprAdminBookPageBgImgPrev').show().attr('src', imgUrl);
	} else {
		jQuery('#dprAdminBookPageBgImgPrev').hide();
	}
}
function dprOnAdminAudioChange(audioUrl, attachment) {
	if(audioUrl && audioUrl != '') {
		var isSoundDefault = audioUrl == dprDefaultAudioPaging;
		jQuery('.dprAdminBookAudioLink').show().attr('href', audioUrl).html( isSoundDefault ? toeLangDpr('Default') : audioUrl );
		if(isSoundDefault) {
			jQuery('.dprAdminBookAudioSetDefaultLink').hide();
		} else {
			jQuery('.dprAdminBookAudioSetDefaultLink').show();
		}
	} else {
		jQuery('.dprAdminBookAudioLink').hide();
		jQuery('.dprAdminBookAudioSetDefaultLink').show();
	}
}
function dprOnAdminOpacitySlideMove(event, ui) {
	toeSliderMove(event, ui);
	if(typeof(dprLivePreviewParams) != 'undefined') {
		dprLivePreviewParams.update({
			bg_opacity: ui.value
		});
	}
}
jQuery(document).ready(function(){
	jQuery('#term_dpr_bg_type').change(function(){
		switch(jQuery(this).val()) {
			case 'color':
				jQuery('#term_dpr_bg_color_shell, #term_dpr_bg_opacity_shell').show();
				jQuery('#term_dpr_bg_img_shell, #term_dpr_bg_img_pos_shell').hide();
				break;
			case 'img':
				jQuery('#term_dpr_bg_color_shell, #term_dpr_bg_opacity_shell').hide();
				jQuery('#term_dpr_bg_img_shell, #term_dpr_bg_img_pos_shell').show();
				break;
			case '':
			default:
				jQuery('#term_dpr_bg_color_shell, #term_dpr_bg_opacity_shell, #term_dpr_bg_img_shell, #term_dpr_bg_img_pos_shell').hide();
				break;
		}
	});
	jQuery('#term_dpr_page_bg_type').change(function(){
		switch(jQuery(this).val()) {
			case 'color':
				jQuery('#term_dpr_page_bg_color_shell, #term_dpr_page_bg_opacity_shell').show();
				jQuery('#term_dpr_page_bg_img_shell, #term_dpr_page_bg_img_pos_shell').hide();
				break;
			case 'img':
				jQuery('#term_dpr_page_bg_color_shell, #term_dpr_page_bg_opacity_shell').hide();
				jQuery('#term_dpr_page_bg_img_shell, #term_dpr_page_bg_img_pos_shell').show();
				break;
			case '':
			default:
				jQuery('#term_dpr_page_bg_color_shell, #term_dpr_page_bg_opacity_shell, #term_dpr_page_bg_img_shell, #term_dpr_page_bg_img_pos_shell').hide();
				break;
		}
	});
	if(jQuery('#term_dpr_bg_type').parents('form:first').attr('id') != 'addtag') {
		jQuery('#term_dpr_bg_type').change();
		jQuery('#term_dpr_page_bg_type').change();
	}
	jQuery('.dprAdminBookAudioSetDefaultLink').click(function(){
		jQuery('[name="dpr[audio_paging]"]').val( dprDefaultAudioPaging );
		dprOnAdminAudioChange(dprDefaultAudioPaging);
		return false;
	});
	jQuery('.dprAdminBookAudioNoSoundLink').click(function(){
		jQuery('[name="dpr[audio_paging]"]').val('');
		dprOnAdminAudioChange('');
		return false;
	});
	jQuery('#term_dpr_en_audio_paging').change(function(){
		dprChangeSoundBtnVisible(jQuery(this).attr('checked'));
	});
	dprChangeSoundBtnVisible(jQuery('#term_dpr_en_audio_paging').attr('checked'));
	dprHideUnusedFormFields();
	jQuery('label[for="name"], label[for="tag-name"]').html(toeLangDpr('Publication Name'));
	// Did not work - after selection on ctrl-c it copy parent element of this span - don't know why
	/*jQuery('.gmpShortCodePreview span').dblclick(function(){
		toeSelectText(jQuery(this));
	});*/
	// After new book creation - we need to redirect user to this book, 
	// book is added as usual tag, see tags.js, via ajax, and there are no actions on clients side,
	// so we have no other chance to do this - as add global ajax succcess event listener 
	// and check each ajax success responce, waiting for responc about book adding.
	jQuery(document).ajaxSuccess(function(event, xhr, settings) {
		var sentData = settings && settings.data  ? parseStr(settings.data) : false;
		if(sentData 
			&& sentData.action == 'add-tag' 
			&& sentData.dpr 
			&& sentData.taxonomy == DPR_DATA.DPR_BOOK
			&& xhr
			&& xhr.responseXML
		) {
			var res = res = wpAjax.parseAjaxResponse( xhr.responseXML, 'ajax-response' );
			if (! res || res.errors)
				return;
			var term = res.responses[1].supplemental;
			if(term && term.term_id) {
				toeRedirect(dprGetBookEditLink(term.term_id));
			}
		}
	});
});
/**
 * We will hide unused fields on add and edit book form
 */
function dprHideUnusedFormFields() {
	jQuery('#tag-slug, #parent, #tag-description, #slug, #description').each(function(){
		jQuery(this).parents('.form-field:first').hide();
	});
}
function dprChangeSoundBtnVisible(val) {
	if(val) {
		jQuery('#term_dpr_audio_paging_input_shell').show(300);
	} else {
		jQuery('#term_dpr_audio_paging_input_shell').hide(300);
	}
}