<?php
	function dprDisplayBookHtmlInput($key, $data, $bookParams, $isAddForm = false) {
		$htmlType = $data['type'];
		if(empty($htmlType)) continue;
		$id = '';
		$inputParams = array();
		$value = isset($bookParams[ $key ]) 
				? $bookParams[ $key ] 
				: (isset($data['default']) ? $data['default'] : '');
		if($value)
			$inputParams['value'] = $value;
		
		$inputParams['attrs'] = isset($data['attrs']) ? $data['attrs'] : '';
		if(strpos($inputParams['attrs'], 'id=') === false) {
			$id = 'term_dpr_'. $key;
			$inputParams['attrs'] .= ' id="'. $id. '"';
		}
		$inputParams['data-original-name'] = $key;
		$name = 'dpr['. $key. ']';
		$idFromName = htmlDpr::nameToClassId($name, $inputParams);
		$shellId = $idFromName. '_shell';
		$inputShellId = $idFromName. '_input_shell';
		if(isset($data['params'])) {
			$inputParams = array_merge($inputParams, $data['params']);
		}
		if($isAddForm && (!isset($data['show_on_create']) || !$data['show_on_create'])) {
			$htmlType = 'hidden';
		}
		return array(
			'shellId' => $shellId,
			'html' => htmlDpr::$htmlType($name, $inputParams),
			'id' => $id,
			'inputShellId' => $inputShellId,
		);
	}
?>
<?php foreach($this->bookParamsDesc as $key => $data) { ?>
	<?php
		if(in_array($key, array('en_audio_paging'))) continue;
		if(isset($data['ignore']) && $data['ignore']) continue;
		if(empty($data['type'])) continue;
		$display = dprDisplayBookHtmlInput($key, $data, $this->bookParams, $this->isAddForm);
		$shellId = $display['shellId'];
		$id = $display['id'];
		$inputShellId = $display['inputShellId'];
		$hideStyle = '';
	?>
	<?php if($this->isAddForm) { // If fields - is for small form of creation of taxonomy ?>
		<?php if(!isset($data['show_on_create']) || !$data['show_on_create']) {
			$hideStyle = 'style="display: none;"';
		}?>
		<div id="<?php echo $shellId?>" class="form-field" <?php echo $hideStyle?>>
			<label for="<?php echo $id?>"><?php echo $data['label']; ?></label>
			<?php if($key == 'audio_paging') {
				$displayEnCheck = dprDisplayBookHtmlInput('en_audio_paging', $this->bookParamsDesc['en_audio_paging'], $this->bookParams);
				echo $displayEnCheck['html'];
			}?>
			<span id="<?php echo $inputShellId?>">
				<?php echo $display['html']?>
				<?php /*if($key == 'bg_img') { ?>
					<img src="" id="dprAdminBookBgImgPrev" style="max-width: 150px" />
				<?php } elseif($key == 'page_bg_img') { ?>
					<img src="" id="dprAdminBookPageBgImgPrev" style="max-width: 150px" />
				<?php } elseif($key == 'audio_paging') { ?>
					<a target="_blank" href="" class="dprAdminBookAudioLink"></a>
					<a target="_blank" href="" class="dprAdminBookAudioSetDefaultLink button"><?php _e('Set default', DPR_LANG_CODE)?></a>
				<?php }*/?>
			</span>
			<?php if(isset($data['desc'])) {?>
				<p><?php echo $data['desc']; ?></p>
			<?php }?>
		</div>
	<?php } else { // If this is tax edit form (page) ?>
		<tr id="<?php echo $shellId?>" class="form-field">
			<th scope="row" valign="top">
				<label for="<?php echo $id?>"><?php echo $data['label']; ?></label>
			</th>
			<td>
				<?php if($key == 'audio_paging') {
					$displayEnCheck = dprDisplayBookHtmlInput('en_audio_paging', $this->bookParamsDesc['en_audio_paging'], $this->bookParams);
					echo $displayEnCheck['html'];
				}?>
				<span id="<?php echo $inputShellId?>">
					<?php if(!in_array($key, array('social_links'))) {?>
						<?php echo $display['html']?>
					<?php }?>
					<?php if($key == 'bg_img') { ?>
						<img src="" id="dprAdminBookBgImgPrev" style="max-width: 150px" />	
					<?php } elseif($key == 'page_bg_img') { ?>
						<img src="" id="dprAdminBookPageBgImgPrev" style="max-width: 150px" />
					<?php } elseif($key == 'audio_paging') { ?>
						<a target="_blank" href="" class="dprAdminBookAudioLink"></a>
						<a target="_blank" href="" class="dprAdminBookAudioSetDefaultLink button"><?php _e('Set default', DPR_LANG_CODE)?></a>
					<?php } elseif($key == 'social_links') {
						echo frameDpr::_()->getModule('social_links')->getAdminEditList(array('input' => $display['html']));
					} elseif($key == 'toolbar_code') { ?>
						<?php foreach($this->toolbars as $tCode => $tData) { ?>
							<a href="#" data-code="<?php echo $tCode?>" class="swrAdminBookToolbarSelectItem">
								<img src="<?php echo $tData['prev_img']?>" />
							</a><br />
						<?php }?>
					<?php }?>
				</span>
				<?php if(isset($data['desc'])) {?>
					<br /><span class="description"><?php echo $data['desc']; ?></span>
				<?php }?>
			</td>
		</tr>
	<?php }?>
<?php }?>
