<?php
class optionsViewDpr extends viewDpr {
	private $_news = array();
	public function getNewFeatures() {
		$res = array();
		$readmePath = DPR_DIR. 'readme.txt';
		if(file_exists($readmePath)) {
			$readmeContent = @file_get_contents($readmePath);
			if(!empty($readmeContent)) {
				$matchedData = '';
				if(preg_match('/= '. DPR_VERSION. ' =(.+)=.+=/isU', $readmeContent, $matches)) {
					$matchedData = $matches[1];
				} elseif(preg_match('/= '. DPR_VERSION. ' =(.+)/is', $readmeContent, $matches)) {
					$matchedData = $matches[1];
				}
				$matchedData = trim($matchedData);
				if(!empty($matchedData)) {
					$res = array_map('trim', explode("\n", $matchedData));
				}
			}
		}
		return $res;
	}
    public function getAdminPage() {
		//frameDpr::_()->addScript('wp.tabs', DPR_JS_PATH. 'wp.tabs.js');
		frameDpr::_()->addScript('postbox');
		frameDpr::_()->addScript('admin.mainoptions', $this->getModule()->getModPath(). 'js/admin.mainoptions.js');
		
		$opts = $this->getModule()->getPlugOptsDesc();
		foreach($opts as $key => $opt) {
			$optVal = $this->getModel()->get($key);
			$opts[ $key ]['value'] = $optVal !== false
				? $optVal 
				: (isset($opt['default']) ? $opt['default'] : '');
		}
		$booksCount = frameDpr::_()->getModule('book')->getModel()->getTotalCount();
		$pagesCount = frameDpr::_()->getModule('page')->getModel()->getTotalCount();

		$this->assign('urlAddBook', frameDpr::_()->getModule('book')->getLinkBookAdd());
		$this->assign('urlAddPage', frameDpr::_()->getModule('page')->getLinkPageAdd());

		$this->assign('booksCount', $booksCount);
		$this->assign('pagesCount', $pagesCount);
		$this->assign('opts', $opts);
		
		$screen = get_current_screen();
		
		//add_meta_box('forNewUsers', __('For new users', DPR_LANG_CODE), array($this, 'forNewUsers'), $screen->id, 'first_col');
		//add_meta_box('userCases', __('User cases', DPR_LANG_CODE), array($this, 'userCases'), $screen->id, 'first_col');
		add_meta_box('videoTutorial', __('Video tutorial', DPR_LANG_CODE), array($this, 'videoTutorial'), $screen->id, 'first_col');
		add_meta_box('publicationsStats', __('Publications stats', DPR_LANG_CODE), array($this, 'publicationsStats'), $screen->id, 'first_col');
		add_meta_box('serverSettings', __('Server settings', DPR_LANG_CODE), array($this, 'serverSettings'), $screen->id, 'first_col');
		
		add_meta_box('newInVersion', sprintf(__('New! %s ver %s', DPR_LANG_CODE), DPR_WP_PLUGIN_NAME, DPR_VERSION), array($this, 'newInVersion'), $screen->id, 'second_col');
		add_meta_box('howUsePublications', __('How to use publications', DPR_LANG_CODE), array($this, 'howUsePublications'), $screen->id, 'second_col');
		
		$news = $this->_getNews();
		if($news) {
			add_meta_box('ourNews', $news->post_title, array($this, 'ourNews'), $screen->id, 'second_col');
		}
		add_meta_box('mainSettings', __('Main settings', DPR_LANG_CODE), array($this, 'mainSettings'), $screen->id, 'second_col');
		add_meta_box('contactUs', __('Contact us', DPR_LANG_CODE), array($this, 'contactUs'), $screen->id, 'second_col');
		
		$this->assign('screen', $screen);

        parent::display('optionsAdminPage');
    }
	private function _getNews() {
		if(empty($this->_news)) {
			$lastTimeNewsUpdated = get_option('ready_news_updated');
			$lastTimeNews = get_option('ready_news');
			if($lastTimeNewsUpdated && $lastTimeNews && time() - $lastTimeNewsUpdated <= 24 * 60 * 60) {
				$this->_news = $lastTimeNews;
			} else {
				$getData = wp_remote_post('http://readyshoppingcart.com/?mod=options&action=getNews&pl=rcs', array(
					'body' => array(
						'site_url' => get_bloginfo('wpurl'),
						'site_name' => get_bloginfo('name'),
						'plugin_code' => DPR_CODE,
					)
				));
				if($getData 
					&& is_array($getData)
					&& isset($getData['response']) 
					&& isset($getData['response']['code']) 
					&& $getData['response']['code'] == 200 
					&& isset($getData['body']) 
					&& !empty($getData['body'])
				) {
					$respDecoded = json_decode($getData['body']);
					if($respDecoded 
						&& is_object($respDecoded) 
						&& isset($respDecoded->data) 
						&& isset($respDecoded->data->newsPost)
					) {
						update_option('ready_news', $respDecoded->data->newsPost);
						update_option('ready_news_updated', time());
						$this->_news = $respDecoded->data->newsPost;
					}
				}
			}
		}
		return $this->_news;
	}
	public function ourNews() {
		$this->assign('news', $this->_getNews());
		return parent::display('_ourNews');
	}
	public function forNewUsers() {
		return parent::display('_forNewUsers');
	}
	public function userCases() {
		return parent::display('_userCases');
	}
	public function videoTutorial() {
		return parent::display('_videoTutorial');
	}
	public function serverSettings() {
		$this->assign('systemInfo', array(
            'Operating System' => array('value' => PHP_OS),
            'PHP Version' => array('value' => PHP_VERSION),
            'Server Software' => array('value' => $_SERVER['SERVER_SOFTWARE']),
            'MySQL' => array('value' => mysql_get_server_info()),
            'PHP Safe Mode' => array('value' => ini_get('safe_mode') ? 'Yes' : 'No', 'error' => ini_get('safe_mode')),
            'PHP Allow URL Fopen' => array('value' => ini_get('allow_url_fopen') ? 'Yes' : 'No'),
            'PHP Memory Limit' => array('value' => ini_get('memory_limit')),
            'PHP Max Post Size' => array('value' => ini_get('post_max_size')),
            'PHP Max Upload Filesize' => array('value' => ini_get('upload_max_filesize')),
            'PHP Max Script Execute Time' => array('value' => ini_get('max_execution_time')),
            'PHP EXIF Support' => array('value' => extension_loaded('exif') ? 'Yes' : 'No'),
            'PHP EXIF Version' => array('value' => phpversion('exif')),
            'PHP XML Support' => array('value' => extension_loaded('libxml') ? 'Yes' : 'No', 'error' => !extension_loaded('libxml')),
            'PHP CURL Support' => array('value' => extension_loaded('curl') ? 'Yes' : 'No', 'error' => !extension_loaded('curl')),
        ));
		return parent::display('_serverSettings');
	}
	public function newInVersion() {
		$this->assign('newFeaturesList', $this->getNewFeatures());
		return parent::display('_newInVersion');
	}
	public function howUsePublications() {
		return parent::display('_howUsePublications');
	}
	public function galleryPluginRelease() {
		return parent::display('_galleryPluginRelease');
	}
	public function publicationsStats() {
		return parent::display('_publicationsStats');
	}
	public function mainSettings() {
		return parent::display('_mainSettings');
	}
	public function contactUs() {
		return parent::display('_contactUs');
	}
}
