<?php
class pagesDpr extends moduleDpr {
    /**
     * Check if current page is Login page
     */
    public function isLogin() {
		return (basename($_SERVER['SCRIPT_NAME']) == 'wp-login.php' 
				|| strpos($_SERVER['REQUEST_URI'], '/login/') === 0);	// Some plugins create login page by this address
    }
	/**
	 * Check if current page - is for our custom tax Book, we need this as we included it into our custom admin menu (didn't create menu from cust tax itself)
	 */
	public function isAdminBooksPage() {
		if(is_admin()) {
			$scriptFile = basename($_SERVER['PHP_SELF']);
			if($scriptFile == 'edit-tags.php' && reqDpr::getVar('taxonomy') == DPR_BOOK) {
				return true;
			}
		}
		return false;
	}
	public function isAdminPagesPage() {
		if(is_admin()) {
			$scriptFile = basename($_SERVER['PHP_SELF']);
			if(($scriptFile == 'edit.php' && reqDpr::getVar('post_type') == DPR_PAGE)
				|| ($scriptFile == 'post-new.php' && reqDpr::getVar('post_type') == DPR_PAGE)
				|| ($scriptFile == 'post.php' && get_post_type(reqDpr::getVar('post')) == DPR_PAGE)
			) {
				return true;
			}
		}
		return false;
	}
	public function getCustomMetaBox($attrs = array()) {
		return $this->getView()->getCustomMetaBox($attrs);
	}
}

