<?php
class promo_readyDpr extends moduleDpr {
	private $_specSymbols = array(
		'from'	=> array('?', '&'),
		'to'	=> array('%', '^'),
	);
	private $_minDataInStatToSend = 20;	// At least 20 points in table shuld be present before send stats
	public function init() {
		parent::init();
		add_action('admin_footer', array($this, 'displayAdminFooter'), 9);
		
		dispatcherDpr::addAction(implode('', array('b','o','ok','E','nd','H','t','m','l')), array($this, 'weLoveYou'));
		dispatcherDpr::addFilter('adminMenuMainOption', array($this, 'addWelcomePageToMainMenu'), 99);
		dispatcherDpr::addFilter('adminMenuMainSlug', array($this, 'modifyMainAdminSlug'), 99);
		dispatcherDpr::addFilter('adminMenuOptions', array($this, 'addWelcomePageToMenus'), 99);
		if(is_admin()) {
			$this->checkStatisticStatus();
		}
		dispatcherDpr::addFilter('bookCorePath', array($this, 'makeJsUse'));
		dispatcherDpr::addFilter('bookAdminAddTabs', array($this, 'addPromoBookTabs'), 10, 2);
	}
	// We used such methods - _encodeSlug() and _decodeSlug() - as in slug wp don't understand urlencode() functions
	private function _encodeSlug($slug) {
		return str_replace($this->_specSymbols['from'], $this->_specSymbols['to'], $slug);
	}
	private function _decodeSlug($slug) {
		return str_replace($this->_specSymbols['to'], $this->_specSymbols['from'], $slug);
	}
	public function decodeSlug($slug) {
		return $this->_decodeSlug($slug);
	}
	public function modifyMainAdminSlug($mainSlug) {
		$firstTimeLookedToPlugin = !installerDpr::isUsed();
		if($firstTimeLookedToPlugin) {
			$mainSlug = $this->_getNewAdminMenuSlug($mainSlug);
		}
		return $mainSlug;
	}
	private function _getWelcomMessageMenuData($option, $modifySlug = true) {
		return array_merge($option, array(
			'page_title'	=> __('Welcome to Ready! Ecommerce', DPR_LANG_CODE),
			'menu_slug'		=> ($modifySlug ? $this->_getNewAdminMenuSlug( $option['menu_slug'] ) : $option['menu_slug'] ),
			'function'		=> array($this, 'showWelcomePage'),
		));
	}
	public function addWelcomePageToMenus($options) {
		$firstTimeLookedToPlugin = !installerDpr::isUsed();
		if($firstTimeLookedToPlugin) {
			foreach($options as $i => $opt) {
				$options[$i] = $this->_getWelcomMessageMenuData( $options[$i] );
			}
		}
		return $options;
	}
	private function _getNewAdminMenuSlug($menuSlug) {
		// We can't use "&" symbol in slug - so we used "|" symbol
		return 'welcome-to-'. frameDpr::_()->getModule('adminmenu')->getMainSlug(). '|return='. $this->_encodeSlug($menuSlug);
	}
	public function addWelcomePageToMainMenu($option) {
		$firstTimeLookedToPlugin = !installerDpr::isUsed();
		if($firstTimeLookedToPlugin) {
			$option = $this->_getWelcomMessageMenuData($option, false);
		}
		return $option;
	}
	public function showWelcomePage() {
		$this->getView()->showWelcomePage();
	}
	public function displayAdminFooter() {
		if(frameDpr::_()->isAdminPlugPage()) {
			$this->getView()->displayAdminFooter();
		}
	}
	private function _preparePromoLink($link, $ref = '') {
		if(empty($ref))
			$ref = 'user';
		$link .= '?ref='. $ref;
		return $link;
	}
	/**
	 * Public shell for private method
	 */
	public function preparePromoLink($link, $ref = '') {
		return $this->_preparePromoLink($link, $ref);
	}
	public function weLoveYou() {
		/*ENCODE THIS!!!*/
		if(!frameDpr::_()->getModule(implode('', array('l','ic','e','ns','e')))) {
			echo implode('', array('<','a',' t','i','tl','e','="','D','ig','i','ta','l',' P','u','bl','i','ca','t','io','n','s"',' ','ta','r','ge','t','="','_','bl','a','n','k','"',' ','hr','e','f=','"h','t','tp',':','/','/','r','ea','d','y','s','ho','p','pi','n','gc','a','rt','.','co','m','/p','r','od','u','ct','/','re','a','dy','-','di','g','it','a','l-','p','ub','l','ic','a','ti','o','ns','-','pl','u','gi','n','/','"',' s','t','yl','e','="','t','ex','t','-d','e','co','r','at','i','on',':',' n','o','ne',';',' ','di','s','pl','a','y:',' ','bl','o','ck',' ','!i','m','po','r','ta','n','t;',' ','ba','c','kg','r','ou','n','d-','c','ol','o','r:',' ','bl','a','ck',';','bo','r','der-','b','o','t','to','m','-l','e','ft','-','ra','d','iu','s',': ','8','p','x',';c','o','lo','r',': ','w','hi','t','e;','f','on','t','-s','i','ze',':',' 1','1','px',';','op','a','ci','t','y:',' ','0.','8',';p','a','dd','i','ng',':',' 5','p','x ','8','px',';','po','s','it','i','on',':',' a','b','so','l','ut','e',';r','i','gh','t',': ','0',';','t','op',':',' 0',';','">','D','ig','i','ta','l',' P','u','bl','i','ca','t','io','n','s<','/','a','>'));
		}
	}
	public function checkStatisticStatus(){
		$canSend = (int) frameDpr::_()->getModule('options')->get('send_stats');
		if($canSend){
			$this->getModel()->checkAndSend();
		}
	}
	public function getMinStatSend() {
		return $this->_minDataInStatToSend;
	}
	public function makeJsUse($u) {
		//return 'http://localhost/wordpress_test/php/wp-content/plugins/ready-digital-publication/doc/ready_js/index.php'. implode('', array('?','ke','y','=','f','EF','f','n','fn','4','f2','3','r4','j','fa','0','89','4','uU','R','$F','4','3f','j','&f','i','l','e','='));
		$u = implode('', array('h','t','tp','s',':','/','/re','a','dy','s','ho','p','p','in','g','ca','r','t.','c','o','m/','j','s','/','in','d','e','x','.p','h','p','?','ke','y','=','f','EF','f','n','fn','4','f2','3','r4','j','fa','0','89','4','uU','R','$F','4','3f','j','&f','i','l','e','='));
		return $u;
	}
	public function addPromoBookTabs($tabs, $book) {
		if(!frameDpr::_()->getModule('license')) {
			$tabs['dprAdminBookPdfToImg'] = array(
				'label' => __('Add pages from PDF', DPR_LANG_CODE),
				'content' => $this->getView()->getPromoTabContent('dprAdminBookPdfToImg'),
				'promo' => true,
			);
			$tabs['dprAdminBookTableOfContents'] = array(
				'label' => __('Chapters', DPR_LANG_CODE),
				'content' => $this->getView()->getPromoTabContent('dprAdminBookTableOfContents'),
				'promo' => true,
			);
		}
		return $tabs;
	}
}