<?php
class social_linksDpr extends moduleDpr {
	private $_availableIcons = array();
	private $_availableDesigns = array();
	private $_addJsData = array();
	public function init() {
		parent::init();
	}
	public function getAdminEditList($d = array()) {
		// We need to use sl instead of socil_links to avoid blocking of AD blocker plugins for browsers
		frameDpr::_()->addScript('admin.sl', DPR_JS_PATH. 'admin.sl.js');
		frameDpr::_()->addStyle('admin.sl', DPR_CSS_PATH. 'admin.sl.css');
		frameDpr::_()->addStyle('sl', DPR_CSS_PATH. 'sl.css');
		return $this->getView()->getAdminEditList($d);
	}
	public function getAvailableIcons() {
		if(empty($this->_availableIcons)) {
			$this->_availableIcons = array(
				'facebook' => array('label' => __('Facebook', DPR_LANG_CODE), 'share_link' => 'https://www.facebook.com/sharer/sharer.php?u='),
				'googleplus' => array('label' => __('Google+', DPR_LANG_CODE), 'share_link' => 'https://plus.google.com/share?url='),
				'twitter' => array('label' => __('Twitter', DPR_LANG_CODE), 'share_link' => 'https://twitter.com/home?status='),
			);
		}
		return $this->_availableIcons;
	}
	public function getAvailableDesigns() {
		if(empty($this->_availableDesigns)) {
			$this->_availableDesigns = array(
				'boxy' => array('label' => __('Boxy', DPR_LANG_CODE)),
				'simple' => array('label' => __('Simple', DPR_LANG_CODE)),
				'night' => array('label' => __('Night', DPR_LANG_CODE)),
			);
		}
		return $this->_availableDesigns;
	}
	public function prepareSocLinks($slStr) {
		if(!empty($slStr)) {
			$desLinks = explode('=', $slStr);
			if(!empty($desLinks[0]) && isset($desLinks[1]) && !empty($desLinks[1])) {
				$res = array('design' => $desLinks[0], 'links_keys' => explode('|', $desLinks[1]));
				if(!empty($res['links_keys'])) {
					$res['links'] = array();
					$currentUrl = uriDpr::getFullUrl();
					$availableIcons = $this->getAvailableIcons();
					foreach($res['links_keys'] as $k) {
						if(!isset($availableIcons[ $k ])) continue;
						$res['links'][ $k ] = $availableIcons[ $k ];
						$res['links'][ $k ]['share_this'] = $res['links'][ $k ]['share_link']. urlencode($currentUrl);
					}
					return $res;
				}
			}
		}
		return false;
	}
	public function loadAssets() {
		frameDpr::_()->addScript('toe_sl', DPR_JS_PATH. 'sl.js');
		frameDpr::_()->addStyle('toe_sl', DPR_CSS_PATH. 'sl.css');
	}
}

