<?php
class templatesDpr extends moduleDpr {
    /**
     * Returns the available tabs
     * 
     * @return array of tab 
     */
    protected $_styles = array();
    public function init() {
		$isAdminPlugOptsPage = frameDpr::_()->isAdminPlugOptsPage();
		$isPluginsPage = utilsDpr::isPluginsPage();
		
		$isBooksPage = frameDpr::_()->getModule('pages')->isAdminBooksPage();
		$isPagePage = frameDpr::_()->getModule('pages')->isAdminPagesPage();
        if (is_admin()) {
			if($isAdminPlugOptsPage || $isPluginsPage || $isBooksPage || $isPagePage) {
				$this->loadCoreJs();
				$this->loadCoreCss();
				frameDpr::_()->addScript('adminOptionsDpr', DPR_JS_PATH. 'admin.options.js');
				add_action('admin_enqueue_scripts', array($this, 'loadMediaScripts'));
				if($isBooksPage) {
					frameDpr::_()->getModule('book')->loadAdminAssets();
				}
				if($isPagePage) {
					frameDpr::_()->getModule('page')->loadAdminAssets();
				}
			}
		}
        parent::init();
    }
	public function loadMediaScripts() {
		wp_enqueue_media();
	}
	public function loadCoreJs() {
		frameDpr::_()->addScript('jquery');
		frameDpr::_()->addScript('jquery-ui-dialog', '', array('jquery'));
		frameDpr::_()->addScript('wp-color-picker');
		//frameDpr::_()->addScript('jquery-ui-slider');
		
		frameDpr::_()->addScript('commonDpr', DPR_JS_PATH. 'common.js');
		frameDpr::_()->addScript('coreDpr', DPR_JS_PATH. 'core.js');

		$ajaxurl = admin_url('admin-ajax.php');
		$jsData = array(
			'siteUrl'					=> DPR_SITE_URL,
			'imgPath'					=> DPR_IMG_PATH,
			'cssPath'					=> DPR_CSS_PATH,
			'loader'					=> DPR_LOADER_IMG, 
			'close'						=> DPR_IMG_PATH. 'cross.gif', 
			'ajaxurl'					=> $ajaxurl,
			'animationSpeed'			=> frameDpr::_()->getModule('options')->get('js_animation_speed'),
			//'siteLang'					=> langDpr::getData(),
			'options'					=> frameDpr::_()->getModule('options')->getAllowedPublicOptions(),
			'DPR_CODE'					=> DPR_CODE,
			'ball_loader'				=> DPR_IMG_PATH. 'ajax-loader-ball.gif',
			'ok_icon'					=> DPR_IMG_PATH. 'ok-icon.png',
			'DPR_BOOK'					=> DPR_BOOK,
			'DPR_PAGE'					=> DPR_PAGE,
			'bookEditUrlPattern'		=> frameDpr::_()->getModule('book')->getLinkBookEdit('DYNAMIC_BOOK_ID')
		);
		$jsData['allCheckRegPlugs']	= modInstallerDpr::getCheckRegPlugs();

		$jsData = dispatcherDpr::applyFilters('jsInitVariables', $jsData);
		frameDpr::_()->addJSVar('coreDpr', 'DPR_DATA', $jsData);
	}
	public function loadCoreCss() {
		$this->_styles = array(
			'jquery-theme'			=> array('path' => DPR_CSS_PATH. 'ui-lightness/jquery-ui-1.8.16.custom.css', 'for' => 'admin'),
			'styleDpr'				=> array('path' => DPR_CSS_PATH. 'style.css', 'for' => 'admin'), 
			'adminStylesDpr'		=> array('path' => DPR_CSS_PATH. 'adminStyles.css', 'for' => 'admin'), 
			'wp-jquery-ui-dialog'	=> array('for' => 'admin'),
			'wp-color-picker'		=> array('for' => 'admin'),
			// Our corrections for ui dialog
			'jquery-dialog'			=> array('path' => DPR_CSS_PATH. 'jquery-dialog.css', 'for' => 'admin'),
			'jquery-slider'			=> array('path' => DPR_CSS_PATH. 'jquery-slider.css', 'for' => 'admin'),
			'dashicons'				=> array('for' => 'admin'),
		);
		foreach($this->_styles as $s => $sInfo) {
			if(isset($sInfo['for'])) {
				if(($sInfo['for'] == 'frontend' && is_admin()) || ($sInfo['for'] == 'admin' && !is_admin()))
					continue;
			}
			$canBeSubstituted = true;
			if(isset($sInfo['substituteFor'])) {
				switch($sInfo['substituteFor']) {
					case 'frontend':
						$canBeSubstituted = !is_admin();
						break;
					case 'admin':
						$canBeSubstituted = is_admin();
						break;
				}
			}
			if($canBeSubstituted && file_exists(utilsDpr::getCurrentWPThemeDir(). 'dpr'. DS. $s. '.css')) {
				frameDpr::_()->addStyle($s, utilsDpr::getCurrentWPThemePath(). '/toe/'. $s. '.css');
			} elseif(!empty($sInfo['path'])) {
				frameDpr::_()->addStyle($s, $sInfo['path']);
			} else {
				frameDpr::_()->addStyle($s);
			}
		}
	}
}
